/*
 * Copyright (c) 1999, 2000  Motoyuki Kasahara.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef PCCARD_ERROR_H
#define PCCARD_ERROR_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Function declarations.
 */
#if defined(__STDC__) || defined(__cplusplus)
void pccard_message_to_stderr(const char *, ...);
void pccard_message_to_nowhere(const char *, ...);
void pccard_set_error_message_handler(void (*)(const char *, ...));
void pccard_set_warning_message_handler(void (*)(const char *, ...));
void pccard_set_debug_message_handler(void (*)(const char *, ...));
void (*pccard_error_message_handler(void))(const char *, ...);
void (*pccard_warning_message_handler(void))(const char *, ...);
void (*pccard_debug_message_handler(void))(const char *, ...);
void pccard_set_debug_flag(void);
void pccard_unset_debug_flag(void);
#else /* not defined(__STDC__) && not defined(__cplusplus) */
void pccard_message_to_stderr();
void pccard_message_to_nowhere();
void pccard_set_error_message_handler();
void pccard_set_warning_message_handler();
void pccard_set_debug_message_handler();
void (*pccard_error_message_handler())();
void (*pccard_warning_message_handler())();
void (*pccard_debug_message_handler())();
void pccard_set_debug_flag();
void pccard_unset_debug_flag();
#endif /* not defined(__STDC__) && not defined(__cplusplus) */

#ifdef __cplusplus
}
#endif

#endif /* not PCCARD_ERROR_H */
